| Home | Libraries | People | FAQ | More

# boost::asio::read

## Functions

template<typename Sync_Read_Stream, typename Mutable_Buffers>
std::size_t | boost::asio::read (Sync_Read_Stream &s, const Mutable_Buffers &buffers)
| Attempt to read a certain amount of data from a stream before returning.
template<typename Sync_Read_Stream, typename Mutable_Buffers, typename Completion_Condition>
std::size_t | boost::asio::read (Sync_Read_Stream &s, const Mutable_Buffers &buffers, Completion_Condition completion_condition)
| Attempt to read a certain amount of data from a stream before returning.
template<typename Sync_Read_Stream, typename Mutable_Buffers, typename Completion_Condition, typename Error_Handler>
std::size_t | boost::asio::read (Sync_Read_Stream &s, const Mutable_Buffers &buffers, Completion_Condition completion_condition, Error_Handler error_handler)
| Attempt to read a certain amount of data from a stream before returning.
template<typename Sync_Read_Stream, typename Allocator>
std::size_t | boost::asio::read (Sync_Read_Stream &s, basic_streambuf< Allocator > &b)
| Attempt to read a certain amount of data from a stream before returning.
template<typename Sync_Read_Stream, typename Allocator, typename Completion_Condition>
std::size_t | boost::asio::read (Sync_Read_Stream &s, basic_streambuf< Allocator > &b, Completion_Condition completion_condition)
| Attempt to read a certain amount of data from a stream before returning.
template<typename Sync_Read_Stream, typename Allocator, typename Completion_Condition, typename Error_Handler>
std::size_t | boost::asio::read (Sync_Read_Stream &s, basic_streambuf< Allocator > &b, Completion_Condition completion_condition, Error_Handler error_handler)
| Attempt to read a certain amount of data from a stream before returning.

## Function Documentation

template<typename Sync_Read_Stream, typename Mutable_Buffers>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | const Mutable_Buffers & | buffers |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffers are full. That is, the bytes transferred is equal to the sum of the buffer sizes.

- An error occurred.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | buffers | One or more buffers into which the data will be read. The sum of the buffer sizes indicates the maximum number of bytes to read from the stream.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Read_Stream::error_type | Thrown on failure.

Example:
  To read into a single data buffer use the boost::asio::buffer function as follows:

       boost::asio::read(s, boost::asio::buffer(data, size));

  See the boost::asio::buffer documentation for information on reading into multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

Note:
  This overload is equivalent to calling:

       boost::asio::read(
           s, buffers,
           boost::asio::transfer_all(),
           boost::asio::throw_error());

template<typename Sync_Read_Stream, typename Mutable_Buffers, typename Completion_Condition>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | const Mutable_Buffers & | buffers,
|  | Completion_Condition | completion_condition |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffers are full. That is, the bytes transferred is equal to the sum of the buffer sizes.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | buffers | One or more buffers into which the data will be read. The sum of the buffer sizes indicates the maximum number of bytes to read from the stream.

  completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Read_Stream::error_type& error, // Result of latest read_some
                                                    // operation.

         std::size_t bytes_transferred              // Number of bytes transferred
                                                    // so far.
       );

  A return value of true indicates that the read operation is complete. False indicates that further calls to the stream's read_some function are required.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Read_Stream::error_type | Thrown on failure.

Example:
  To read into a single data buffer use the boost::asio::buffer function as follows:

       boost::asio::read(s, boost::asio::buffer(data, size),
           boost::asio::transfer_at_least(32));

  See the boost::asio::buffer documentation for information on reading into multiple buffers in one go, and how to use it with arrays, boost::array or std::vector.

Note:
  This overload is equivalent to calling:

       boost::asio::read(
           s, buffers, completion_condition,
           boost::asio::throw_error());

template<typename Sync_Read_Stream, typename Mutable_Buffers, typename Completion_Condition, typename Error_Handler>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | const Mutable_Buffers & | buffers,
|  | Completion_Condition | completion_condition,
|  | Error_Handler | error_handler |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffers are full. That is, the bytes transferred is equal to the sum of the buffer sizes.

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | buffers | One or more buffers into which the data will be read. The sum of the buffer sizes indicates the maximum number of bytes to read from the stream.

  completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Read_Stream::error_type& error, // Result of latest read_some
                                                    // operation.

         std::size_t bytes_transferred              // Number of bytes transferred
                                                    // so far.
       );

  A return value of true indicates that the read operation is complete. False indicates that further calls to the stream's read_some function are required.

  error_handler

  A handler to be called when the operation completes, to indicate whether or not an error has occurred. Copies will be made of the handler as required. The function signature of the handler must be:

       void error_handler(
         const Sync_Read_Stream::error_type& error // Result of operation.
       );

  The error handler is only called if the completion_condition indicates that the operation is complete.

Returns:
  The number of bytes read. If an error occurs, and the error handler does not throw an exception, returns the total number of bytes successfully transferred prior to the error.

template<typename Sync_Read_Stream, typename Allocator>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | basic_streambuf< Allocator > & | b |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- An error occurred.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | b | The basic_streambuf object into which the data will be read.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Read_Stream::error_type | Thrown on failure.

Note:
  This overload is equivalent to calling:

       boost::asio::read(
           s, b,
           boost::asio::transfer_all(),
           boost::asio::throw_error());

template<typename Sync_Read_Stream, typename Allocator, typename Completion_Condition>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | basic_streambuf< Allocator > & | b,
|  | Completion_Condition | completion_condition |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | b | The basic_streambuf object into which the data will be read.

  completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Read_Stream::error_type& error, // Result of latest read_some
                                                    // operation.

         std::size_t bytes_transferred              // Number of bytes transferred
                                                    // so far.
       );

  A return value of true indicates that the read operation is complete. False indicates that further calls to the stream's read_some function are required.

Returns:
  The number of bytes transferred.

Exceptions:

  | Sync_Read_Stream::error_type | Thrown on failure.

Note:
  This overload is equivalent to calling:

       boost::asio::read(
           s, b, completion_condition,
           boost::asio::throw_error());

template<typename Sync_Read_Stream, typename Allocator, typename Completion_Condition, typename Error_Handler>

std::size_t boost::asio::read | ( | Sync_Read_Stream & | s,
|  | basic_streambuf< Allocator > & | b,
|  | Completion_Condition | completion_condition,
|  | Error_Handler | error_handler |
| ) |  |  |

Attempt to read a certain amount of data from a stream before returning.

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The completion_condition function object returns true.

This operation is implemented in terms of one or more calls to the stream's read_some function.

Parameters:

  | s | The stream from which the data is to be read. The type must support the Sync_Read_Stream concept.
  | b | The basic_streambuf object into which the data will be read.

  completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

       bool completion_condition(
         const Sync_Read_Stream::error_type& error, // Result of latest read_some
                                                    // operation.

         std::size_t bytes_transferred              // Number of bytes transferred
                                                    // so far.
       );

  A return value of true indicates that the read operation is complete. False indicates that further calls to the stream's read_some function are required.

  error_handler

  A handler to be called when the operation completes, to indicate whether or not an error has occurred. Copies will be made of the handler as required. The function signature of the handler must be:

       void error_handler(
         const Sync_Read_Stream::error_type& error // Result of operation.
       );

  The error handler is only called if the completion_condition indicates that the operation is complete.

Returns:
  The number of bytes read. If an error occurs, and the error handler does not throw an exception, returns the total number of bytes successfully transferred prior to the error.

| Copyright © 2003 - 2006 Christopher M. Kohlhoff